/*
 * rbCTypes.h 
 * redBlocks Library - Version 2.13.0 - Evaluation Version.
 * Copyright  redlogix Software & System Engineering GmbH, 2012-2020. All rights reserved. 
 *
 * The source code in this file may be incomplete compared to its Commercial Version's counterpart. 
 * However, it may be used in its present form for developing commercial applications if at least 
 * one component of the redBlocks Library is commercially licensed for the respective application.
 * 
 * If not being used together with at least one commercially licensed component of the redBlocks 
 * Library it may be used for evaluation purposes ONLY. 
 *
 * In any case you may not: 
 * (a) to a third party, transfer rights or usage to, sublicense, rent, lease or otherwise distribute 
 *     the source code, or any portions thereof, except with redlogix's prior written consent.
 * (b) create derivative source code of the software.
 * (c) modify, loan, decompile, reverse engineer or disassemble or otherwise distribute the software, 
 *     except with redlogix's prior written consent.
 * (d) remove any intellectual property notices within the software.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITH POTENTIAL FAULTS.
 * NO WARRANTIES, WHETHER EXPLICITLY EXPRESSED, IMPLIED OR STATUTORY, INCLUDING, BUT
 * NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. REDLOGIX SHALL NOT, UNDER ANY
 * CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
 * DAMAGES, FOR ANY REASON WHATSOEVER.
 */

// see rbLegacyIncludes.h. for a description of the following lines
#ifdef RB_LEGACY_INCLUDES_H_
#undef s8
#undef u8
#undef s16
#undef u16
#undef s32
#undef u32
#undef s64
#undef u64
#undef RB_LEGACY_INCLUDES_H_
#endif

#ifndef RB_C_TYPES_H_
#define RB_C_TYPES_H_

#include <rbConfig.h>

/** Data type definitions */
#if RB_USE_STDINT_TYPES

#include <stdint.h>
typedef uint8_t   u8;
typedef int8_t   s8;
typedef uint16_t  u16;
typedef int16_t  s16;
typedef uint32_t  u32;
typedef int32_t  s32;
typedef uint64_t  u64;
typedef int64_t  s64;

#else

typedef unsigned char       u8;
typedef signed char         s8;
typedef unsigned short      u16;
typedef signed short        s16;
typedef unsigned long       u32;
typedef signed long         s32;
typedef unsigned long long  u64;
typedef signed long long    s64;

#endif

#include <stdbool.h>

/** Definition of the NULL Pointer constant */
#ifndef NULL
#define NULL 0
#endif // NULL

#endif // RB_C_TYPES_H_

